<?php
/**
* @version		1.3: jsocial_comments.php
* @copyright	Copyright (C) 2011 PloPixel. All rights reserved.
* @license		GNU General Public License version 2 or later; see LICENSE.txt
*/

// No direct access
defined('_JEXEC') or die;

jimport('joomla.plugin.plugin');

class plgSystemJSocial_Comments extends JPlugin
{
	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		$this->loadLanguage();
	}

	public function onAfterRender()
	{
		$app = JFactory::getApplication();
		if ($app->getName() != 'site') {
			return;
		}

		$view = JRequest::getVar('view');
		$layout = JRequest::getVar('layout');
		$show_featured = $this->params->get('show_featured', 0);
		$show_blog = $this->params->get('show_blog', 0);
		if(($view == 'featured' && $show_featured) || ($view == 'category' && $layout == 'blog' && $show_blog) || $view == 'article') {

			$html = JResponse::getBody();

			// Lang
			if ($this->params->get('auto_language')) {
				$lang_code = str_replace('-', '_', JFactory::getLanguage()->getTag());
			} else {
				$lang_code = $this->params->get('language_tag', 'en_GB');
			}

			// Search for Facebook div
			if (strpos($html, 'id="fb-root') === false) {
				$html = preg_replace("/<body(.*?)>/i", "<body$1>\n<div id=\"fb-root\"></div><script src=\"http://connect.facebook.net/".$lang_code."/all.js#xfbml=1\"></script>", $html);
			} else if (strpos($html, 'connect.facebook.net/en_US/') !== false) {
				$html = str_replace ('connect.facebook.net/en_US/', 'connect.facebook.net/'.$lang_code.'/', $html);
			}

			// Replace FB meta name to property
			if (strpos($html, 'property="') === false && strpos($html, 'name="fbtag_') !== false) {
				$html = str_replace ('name="fbtag_', 'property="', $html);
			}
			JResponse::setBody($html);
		}
	}

	public function onContentAfterDisplay($context, &$row, &$params, $page=0)
	{
		$html = '';
		$app = JFactory::getApplication();
		$view = JRequest::getVar('view');
		$layout = JRequest::getVar('layout');
		$show_featured = $this->params->get('show_featured', 0);
		$show_blog = $this->params->get('show_blog', 0);
		$show_article = $this->params->get('show_article', 0);

		if(($view == 'featured' && $show_featured) || ($view == 'category' && $layout == 'blog' && $show_blog) || $view == 'article') {

			// Filter Cat id
			$catid = $row->catid;
			$allow_cat = $this->params->get('catid');
			if (!in_array($catid, $allow_cat)) {
				return '';
			}

			// CSS
			$color_scheme = $this->params->get('color_scheme', 0);
			if ($color_scheme == 1) {
				$css = 'plugins/system/jsocial_comments/assets/dark.css';
			} else {
				$css = 'plugins/system/jsocial_comments/assets/light.css';
			}
			$document =& JFactory::getDocument();
			$document->addStyleSheet(JURI::root() . $css);

			// Add Facebook Meta
			if ($view == 'article') {
				$fb_userid = $this->params->get('fb_userid');
				$fb_appid = $this->params->get('fb_appid');
				if ($fb_userid) $document->setMetaData('fbtag_fb:admins', $fb_userid);
				if ($fb_appid) $document->setMetaData('fbtag_fb:app_id', $fb_appid);
				if ($this->params->get('default_image', 0)) {
					$image = $this->params->get('article_image', '');
					if (!file_exists($image)) {
						$image = 'plugins/system/jsocial_comments/assets/no_image.jpg';
					}
				} else {
					$image = $this->getImage($row->text);
				}
				$document->setMetaData('fbtag_og:image', JURI::root().$image);
				$text = ($row->metadesc) ? $row->metadesc.' | '.$row->introtext : $row->introtext;
				$desc = JFilterOutput::cleanText($text);
				$sep = (mb_strlen($desc) > 300) ? '...' : '';
				$desc = ($sep) ? utf8_substr($desc, 0, 297).$sep : $desc;
				$document->setMetaData('fbtag_og:description', $desc);
			}

		} else {
			return '';
		}

		$article_url = rtrim(JURI::root(), '/').JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catid));

		// Comments count
		if(($view == 'featured' && $show_featured) || ($view == 'category' && $layout == 'blog' && $show_blog) || ($view == 'article' && $show_article)) {
			$html .= '<div class="jsocial-comments-count"><a href="'.$article_url.'#comments" title="'.JText::_('PLG_SYSTEM_JSOCIAL_COMMENTS_COMMENTS_ADD').'"><span class="jsocial-comments-text">'.JText::_('PLG_SYSTEM_JSOCIAL_COMMENTS_COMMENTS').'</span>(<fb:comments-count href='.$article_url.'></fb:comments-count>)</a></div>';
		}

		// Facebook comments
		if ($view == 'article') {
			$post_count = $this->params->get('post_count', 5);
			$comment_width = $this->params->get('comment_width', 500);
			$html .= '<a name="comments" id="comments"></a>';
			$html .= '<div class="jsocial-comments"><fb:comments href="'.$article_url.'" num_posts="'.$post_count.'" width="'.$comment_width.'"'.($color_scheme == 1 ? ' colorscheme="dark"' : '').'></fb:comments></div>';
			$comment_cache = (int) $this->params->get('comment_cache', 600);
			$feed = $this->fbComments($article_url, $comment_cache);
			if ($feed != false && count($feed) > 0) {
				$html .= '<div class="jsocial-comments-feeds">';
				$html .= '<span>'.JText::_('PLG_SYSTEM_JSOCIAL_COMMENTS_ROBOTS_MESSAGE').'</span>';
				foreach ($feed as $value) {
					$html .= ' '.$value.' ';
				}
				$html .= '</div>';
				unset($value);
			}
		}
		return $html;
	}

	private function fbComments($feed_url, $cache_time) {
		$cache_file = JPATH_BASE.DS.'cache'.DS.'jsocial_comments_cache_'.md5($feed_url);
		$feed_url = 'https://graph.facebook.com/comments/?ids=' . urlencode($feed_url);

		if ( !file_exists($cache_file) || time() - filemtime($cache_file) > $cache_time ) {

			$cache_rss = @file_get_contents($feed_url);
			if ($cache_rss) {

				$cache_static = fopen($cache_file, 'wb');
				fwrite($cache_static, serialize($cache_rss));
				fclose($cache_static);
			}
			$rss = @unserialize(@file_get_contents($cache_file));
		} else {
			$rss = @unserialize(@file_get_contents($cache_file));
		}

		$result = json_decode($rss, true);
		if (is_array($result)) {
			$result = array_pop($result);
			if (array_key_exists('data', $result)) {
				if (count($result['data']) > 0) {
					return $this->getMessages($result);
				}
			}
		}
		return false;
	}

	private function getMessages($array) {
		$flat = array();
		foreach ($array as $key => $value) {
			if (is_array($value)) {
				$flat = array_merge($flat, $this->getMessages($value));
			} else if ($key == 'message') {
				if ($this->cleanMessage($value)) {
					$flat[] = $value;
				}
			}
		}
		return $flat;
	}

	private function cleanMessage($message) {
		$search = array('@<script[^>]*?>.*?</script>@si',
		'@<[\/\!]*?[^<>]*?>@si',
		'@<style[^>]*?>.*?</style>@siU',
		'@<![\s\S]*?--[ \t\n\r]*>@'
		);
		$text = preg_replace($search, '', $message);
		$text = preg_replace('{( ?.)\1{4,}}', '$1$1$1', $text);
		return trim(strip_tags($text));
	}

	function getImage($text) {
		preg_match('/< *img[^>]*src *= *["\']?([^"\']*)/i', $text, $matches);

		//If no image found
		if (!isset($matches[1])) {
			$matches[1] = $this->params->get('article_image', '');
		}

		if (!file_exists($matches[1])) {
			$matches[1] = 'plugins/system/jsocial_comments/assets/no_image.jpg';
		}
		return $matches[1];
	}
}